#!/usr/bin/env node
import chalk from 'chalk';
import gradient from 'gradient-string';
import inquirer from 'inquirer';
import chalkAnimation from 'chalk-animation';
import figlet from 'figlet';
import { createSpinner} from 'nanospinner';


// global declarations 
let playerName
 const sleep=(ms = 2000) => new Promise((r) => setTimeout(r, ms));
 async function welcome(){
   const title=chalkAnimation.rainbow('Are you really a Weeb ? , lets find out through a small quiz');

   // running the timer for a few seconds
   await sleep();
   title.stop();

   console.log(`
   ${chalk.bgBlue('RULES OF THE GAME !! ')}
   ${chalk.bgRed('(Please do give it a read )')}
   You will have to answer a set of 5 questions
   If you make a mistake in even one of them the quiz will be terminated.
   
   `);
  
   const conclude=chalkAnimation.radar('BEST OF LUCK !!!!! 頑張れ 先輩 !!!!');
   await sleep ();
   conclude.stop();
 }



async function askName(){
 
const recieveName= await inquirer.prompt({
    name: 'player_name',
    type: 'input',
    message: 'What is your name ?',
    default(){
        return 'Senpai';
    }
});
playerName=recieveName.player_name;


}

async function question_1(){
 const question= await inquirer.prompt({
    name:'question_1',
    type:'list',
    message:"Who is Monkey D Luffy's Father ?",
    choices:[
         'Gol D Roger',
         'Monkey D Garp',
         'Monkey D Dragon',
         'Rocks D Xebec'
    ]
 })
 return(handleAnswer(question.question_1=='Monkey D Dragon'))
};
async function question_2(){
    const question= await inquirer.prompt({
       name:'question_2',
       type:'list',
       message:"Who is Vegeta's Brother ?",
       choices:[
            'Turles',
            'Shallot',
            'Raditz',
            'Tarble'
       ]
    })
    return(handleAnswer(question.question_2=='Tarble'))
   };
   async function question_3(){
    const question= await inquirer.prompt({
       name:'question_3',
       type:'list',
       message:"Choose the correct option: Bungee Gum has the properties of ?",
       choices:[
            'Gum and Glue',
            'Clue and Gum',
            'Flex tape and Rubber',
            'Rubber and Gum'
       ]
    })
    return(handleAnswer(question.question_3=='Rubber and Gum'))
   };
   async function question_4(){
    const question= await inquirer.prompt({
       name:'question_4',
       type:'list',
       message:"Which one of them is not a pure blooded Otsusuki ?",
       choices:[
            'Hagoromo Ōtsutsuki',
            'Kaguya Ōtsutsuki',
            'Ishiki Ōtsutsuki',
            'Momoshiki Ōtsutsuki'
       ]
    })
    return(handleAnswer(question.question_4=='Hagoromo Ōtsutsuki'));
   };
   async function question_5(){
    const question= await inquirer.prompt({
       name:'question_1',
       type:'list',
       message:"What is the name of the Sword used by Guts ?",
       choices:[
            'Crimson Behelit',
            'Apostle Slayer',
            'Dragon Slayer',
            'Wado Ichimonji'
       ]
    })
    return(handleAnswer(question.question_1=='Dragon Slayer'))
   };

async function handleAnswer(isCorrect){
    const spinner= createSpinner('Checking........').start();
    await  sleep();

    if(isCorrect){
        spinner.success({text:`That's Great Senpai ${playerName}.`});
    }
    else{
        spinner.error({text:`Game Over ${playerName} Senpai !! Better Luck Next Time`});
        process.exit(1);
    }
}
function winner(){
    console.clear();
    const msg=`Congratulations !!! ${playerName}`;
    figlet(msg,(err,data)=>{
      console.log(gradient.pastel.multiline(data));
    });
}
await welcome();
await askName();
await question_1();
await question_2();
await question_3();
await question_4();
await question_5();
await winner();